c       
c	Limit Set of Maskit Group
	subroutine cirset
	logical yesno
	integer lev
	common /level/ lev
c	INITIATE TREE
	call init
c	MAIN BRANCHING: TEST TO SEE WHETHER OR NOT TO GO FORWARD
C       IF YESNO = .TRUE. KEEP GOING FORWARD;
c       OTHERWISE, GO BACKWARDS.
 40	call test(yesno)
	if(yesno) then
c	PLOT CURRENT CIRCLE AND GO FORWARD ONE VERTEX 
	   call plotx
	   call forwrd
	   go to 40
	end if
c	GO BACK TO FIRST AVAILABLE TURN AND TURN ONCE
	call bckwrd
c	CHECK TO SEE IF THE END HAS BEEN REACHED
C       IF YESNO .EQ. .TRUE. STOP 
	if(lev .gt. 1) go to 40
	call gfxdoc('End circles')
	call offgrf
	end
c       
c	INITIATE TREE
	subroutine init
	complex*16 cen(300),mu,mu0,muchn 
	real*8 rad(300),sigma,tau,thresh,xmin,ymin,xmax,ymax
	integer p(300),q(300),delta(300),denom(300)
	integer lev,pcusp,qcusp,chntype
	common /crit/ mu0,muchn,pcusp,qcusp,chntype
	common /mublk/ mu, sigma, tau
	common /threshb/ thresh
	common /level/ lev
	common /fract/ p,q,delta,denom
	common /center/ cen
	common /radius/ rad
	common /picwin/ xmin,ymin,xmax,ymax
c	GET MU FOR LIMIT SET
	write(*,*) 'Enter mu for limit set (complex): '
	if(chntype.eq.0) then
	   mu=mu0
	else
	   mu=muchn
	end if
	write(*,*) 'Default value:  ',mu
	read(*,*) mu
	sigma=dreal(mu)
	tau=dimag(mu)
c	GET VISIBILITY
	thresh=0.01
	write(*,*) 'Enter visibility threshold: (',thresh,')'
	read(*,*) thresh
	write(2,300)  sigma,tau
 300	format('Limit set mu =',F9.6,'+i',F9.6)
	call ongrf(1)
	call swindw(xmin,ymin,xmax,ymax)
	call smove(xmin,tau)
	call sline(xmax,tau)
	call gfxdoc('Begin circles')
c	INITIATE TREE
	denom(1) = 1.0/ dsqrt(2*tau*thresh)
	p(1) = 1 - denom(1)
	q(1) = denom(1)
	delta(1) = 1- 2*mod(q(1),2)
	rad(1) = 1.0 / (2.0*tau*denom(1)*denom(1))
	cen(1) = dcmplx( (dreal(p(1))/q(1)), rad(1))
	lev = 2
	end
c       
c	TEST FOR VISIBLE CIRCLE
	subroutine test(yesno)
	integer lev
	real*8 thresh, rad(300)
	logical yesno
	common /threshb/ thresh
	common /level/ lev
	common /radius/ rad
	yesno = .true.
	if(lev .eq. 2) return
c	BASIC THRESHOLD
	if(rad(lev-1) .gt. thresh) return
C	FIRST IMPROVEMENT: DETECT SLOW DECAY OF RADIUS
c	Theoretical:   .gt. thresh*thresh
	if(rad(lev-1) .ge. .6*rad(lev-2) .and.
	1    rad(lev-1) .gt. thresh/20) return
	yesno=lev.gt.3
	if(.not.yesno) return
c	DETECT A PRECEDING INCREASE IN RADIUS
	yesno = rad(lev-2) .ge. rad(lev-3) .and.
	1    rad(lev-1) .gt. thresh/20
	end
c       
c	FIND A BOUND FOR THE HEIGHT OF THE FRACTION FOR NEXT LEVEL
	real*8 function bound(a,b,c,d)
	complex*16 a,b,c,d,mu
	real*8 thresh,sigma,tau,z
	common /mublk/ mu, sigma, tau
	common /threshb/ thresh
c	IM( C DBAR ) (KNOWN TO BE POSITIVE)
	z=dimag(c*dconjg(d))
	z=dsqrt( ( 0.5/thresh + z )/tau )/z
	bound=z*dmax1(cdabs(c),cdabs(d))+1
	end
c       
c	GO FORWARD IN TREE
	subroutine forwrd
	complex*16 at(300),bt(300),ct(300),dt(300),cen(300),mu 
	complex*16 fac(4),a,b,tgnt,ii
	integer p(300), q(300), delta(300), denom(300),l
	real*8 rad(300),x,sigma, tau,bound
	common /mublk/ mu, sigma, tau
	common /level/ l
	common /tree/ at,bt,ct,dt
	common /fract/ p,q,delta,denom
	common /center/ cen
	common /radius/ rad
	data ii/(0.0,1.0)/
c	FIND A MATRIX FAC IN GAMMA THAT HAS ONE COLUMN EQUAL TO (P,Q)
	call gamma2(fac,p(l-1),q(l-1))
c	COMPUTE NEXT WORD
	if(delta(l-1) .eq. 1) then
C	COMPUTE FAC * T
	   at(l-1) = -ii*(fac(1)*mu + fac(2))
	   bt(l-1) = -ii*fac(1)
	   ct(l-1) = -ii*(fac(3)*mu + fac(4))
	   dt(l-1) = -ii*fac(3)
	else
c	COMPUTE FAC * T^-1
	   at(l-1) = ii*fac(2)
	   bt(l-1) = ii*(fac(1) - mu*fac(2))
	   ct(l-1) = ii*fac(4)
	   dt(l-1) = ii*(fac(3) - mu*fac(4))
	end if
c	MULTIPLY NEW TERM ON END OF WORD (GIVE FINAL DEFINITION OF m(LEV-1))
	if(l .gt. 2) then
	   a = at(l-2)*at(l-1) + bt(l-2)*ct(l-1)
	   b = at(l-2)*bt(l-1) + bt(l-2)*dt(l-1)
	   ct(l-1) = ct(l-2)*at(l-1) + dt(l-2)*ct(l-1)
	   dt(l-1) = ct(l-2)*bt(l-1) + dt(l-2)*dt(l-1)
	   at(l-1) = a
	   bt(l-1) = b
	end if
c	COMPUTE BOUND ON NUMERATOR AND DENOMINATOR OF NEXT LEVEL
	denom(l) = bound(at(l-1),bt(l-1),ct(l-1),dt(l-1))
C	ALWAYS CHOOSE EVEN DENOMINATOR
	if(mod(denom(l),2) .ne. 0) denom(l) = denom(l)+1
C	START FIRST FRACTION OF NEXT LEVEL
	if(delta(l-1) .ne. 1) then
	   p(l)= -denom(l)
	   q(l)= 1
	   delta(l)=-1
	else
	   p(l)= 1
	   q(l)= denom(l)
	   delta(l)=1
	end if
	x=cdabs(p(l)*ct(l-1)+q(l)*dt(l-1)) 
	rad(l) = 1.0/(2.0*tau*x*x -1.0/rad(l-1))
c	IDENTIFY TANGENT POINT
	tgnt = (at(l-1)*p(l) + bt(l-1)*q(l))
	1    /(ct(l-1)*p(l) + dt(l-1)*q(l))
	cen(l) = cen(l-1) + (1+rad(l)/rad(l-1))*(tgnt-cen(l-1))
	l=l+1
	end
c       
c	PLOT CIRCLES IN FRAME (THERE ARE FIVE POSSIBLE TRANSLATES)
	subroutine plotx
	integer lev,shift0,shift1,i
	complex*16 cen(300),mu
	real*8 rad(300),x,y,r,sigma,tau,xmin,ymin,xmax,ymax
	common /mublk/ mu,sigma,tau
	common /level/ lev
	common /center/ cen
	common /radius/ rad
	common /picwin/ xmin,ymin,xmax,ymax
	x=dreal(cen(lev-1))
	y=dimag(cen(lev-1))
	r=rad(lev-1)
	shift0=((xmin-x-r)/2)
	if(x+r +2*shift0 .lt. xmin) shift0=shift0+1
	shift1=((xmax-x+r)/2)
	if(x-r +2*shift1 .gt. xmax) shift1=shift1-1
	do 10 i=shift0,shift1
 	   call scirc(x+2*i,y,r)
 10	continue
	shift0=((xmin-sigma+x-r)/2)
	if(sigma-x+r +2*shift0 .lt. xmin) shift0=shift0+1
	shift1=((xmax-sigma+x+r)/2)
	if(sigma-x-r +2*shift1 .gt. xmax) shift1=shift1-1
	do 20 i=shift0,shift1
 	   call scirc(sigma-x+2*i,tau-y,r)
 20	continue
	end
c       
c	GO BACKWARD IN TREE AND MAKE ONE TURN
	subroutine bckwrd
	complex*16 at(300),bt(300),ct(300),dt(300),cen(300),mu,tgnt
	integer p(300), q(300), delta(300), denom(300),lev,r,s
	real*8 rad(300),sigma, tau,x
	common /mublk/ mu, sigma, tau
	common /level/ lev
	common /tree/ at,bt,ct,dt
	common /fract/ p,q,delta,denom
	common /center/ cen
	common /radius/ rad
 5	lev = lev -1
	if(lev .eq. 1) then
c	END OF PROGRAM REACHED
	   if(p(1) .eq. denom(1)-1) return
c	FIRST LEVEL BRANCHING
	   r=p(1)
	   s=q(1)
	   call farey(r,s,denom(1))
	   p(1)=r
	   q(1)=s
	   delta(1) = 1 -2*mod(q(1),2)
	   rad(1) = 1.0 / (2.0*tau* q(1)**2)
	   cen(1) = dcmplx( (dreal(p(1))/q(1)), rad(1))
c	HIGHER LEVEL BRANCHING
	else 
	   if(delta(lev-1) .ne. 1) then
	      r = p(lev)
	      s = q(lev)
	   else
C	REPLACE P/Q WITH -Q/P AND ARRANGE FOR POSITIVE DENOMINATOR
	      r = isign(q(lev),-p(lev))
	      s = abs(p(lev))
	   end if
C	NO MORE BRANCHING POSSIBLE
	   if((r .eq. denom(lev)) .and. (s .eq. 1))  go to 5
C	IF BRANCHING POSSIBLE, GET NEXT FRACTION IN FAREY SERIES
	   call farey(r,s,denom(lev))
	   if(delta(lev-1) .ne. 1) then
	      p(lev) = r
	      q(lev) = s
	   else
	      p(lev) = isign(s,-r)
	      q(lev) = abs(r)
	   end if
	   delta(lev) = 1- 2*mod(q(lev),2)
c	GENERATE CIRCLE AT THIS LEVEL
	   x=cdabs(p(lev)*ct(lev-1)+q(lev)*dt(lev-1)) 
	   rad(lev) = 1.0/(2.0*tau*x*x -1.0/rad(lev-1))
c	IDENTIFY TANGENT POINT
	   tgnt = (at(lev-1)*p(lev) + bt(lev-1)*q(lev))
	1	/(ct(lev-1)*p(lev) + dt(lev-1)*q(lev))
	   cen(lev) = 
	1	cen(lev-1)+(1+rad(lev)/rad(lev-1))*(tgnt-cen(lev-1))
	end if
c	START GOING FORWARD AGAIN
	lev = lev +1
	end
c       
c	FIND THE NEXT FRACTION IN THE FAREY SEQUENCE
c	WITH DENOMINATOR OR NUMERATOR EVEN
	subroutine farey(p0,q0,denom0)
	integer denom0,p0,q0,denom,p,q,i
	p=p0
	q=q0
	denom=denom0
	if(p .lt. -q .or. p .ge.q .or. q.eq.0) then
	   i=q
	   q=abs(p)
	   p=isign(i,p)
 30	   call nextpq(p,q,denom,-1)
	   if(mod(p+q,2) .eq. 0) go to 30
	   i=q
	   q=abs(p)
	   p=isign(i,p)
	else
 10	   call nextpq(p,q,denom,1)
	   if(mod(p+q,2) .eq. 0) go to 10
	end if
	p0=p
	q0=q
	end
c       
c	FIND A MATRIX IN GAMMA(2) WITH (P,Q) AS A COLUMN
	subroutine gamma2(fac,p,q)
	integer p,q,h,k
	complex*16 fac(4)
	if(q.eq.0) then
	   fac(1)=1
	   fac(2)=0
	   fac(3)=0
	   fac(4)=1
	else
	   h=p
	   k=q
	   call nextpq(h,k,q,1)
	   if(mod(h+k,2).eq.0) then
	      h=h+p
	      k=k+q
	   end if
	   if(mod(p,2) .eq. 0) then
	      fac(1)=h
	      fac(2)=p
	      fac(3)=k
	      fac(4)=q
	   else
	      fac(1)=p
	      fac(2)=-h
	      fac(3)=q
	      fac(4)=-k
	   end if
	end if
	end
